# encoding: utf-8
# **********************************************************************
#
# Copyright (c) 2003-2016 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************
#
# Ice version 3.6.3
#
# <auto-generated>
#
# Generated from file `PermissionsVerifier.ice'
#
# Warning: do not edit this file.
#
# </auto-generated>
#

require 'Ice'
require 'Glacier2/SSLInfo.rb'

module Glacier2

    if not defined?(::Glacier2::PermissionDeniedException)
        class PermissionDeniedException < Ice::UserException
            def initialize(reason='')
                @reason = reason
            end

            def to_s
                'Glacier2::PermissionDeniedException'
            end

            attr_accessor :reason
        end

        T_PermissionDeniedException = ::Ice::__defineException('::Glacier2::PermissionDeniedException', PermissionDeniedException, true, nil, [["reason", ::Ice::T_string, false, 0]])
        PermissionDeniedException::ICE_TYPE = T_PermissionDeniedException
    end

    if not defined?(::Glacier2::PermissionsVerifier_mixin)
        module PermissionsVerifier_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Glacier2::PermissionsVerifier', '::Ice::Object']
            end

            def ice_id(current=nil)
                '::Glacier2::PermissionsVerifier'
            end

            #
            # Operation signatures.
            #
            # def checkPermissions(userId, password, current=nil)

            def inspect
                ::Ice::__stringify(self, T_PermissionsVerifier)
            end
        end
        class PermissionsVerifier
            include PermissionsVerifier_mixin
            
            def PermissionsVerifier.ice_staticId()
                '::Glacier2::PermissionsVerifier'
            end
        end
        module PermissionsVerifierPrx_mixin

            def checkPermissions(userId, password, _ctx=nil)
                PermissionsVerifier_mixin::OP_checkPermissions.invoke(self, [userId, password], _ctx)
            end
        end
        class PermissionsVerifierPrx < ::Ice::ObjectPrx
            include PermissionsVerifierPrx_mixin

            def PermissionsVerifierPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::Glacier2::PermissionsVerifier', facetOrCtx, _ctx)
            end

            def PermissionsVerifierPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
            def PermissionsVerifierPrx.ice_staticId()
                '::Glacier2::PermissionsVerifier'
            end
        end

        if not defined?(::Glacier2::T_PermissionsVerifier)
            T_PermissionsVerifier = ::Ice::__declareClass('::Glacier2::PermissionsVerifier')
            T_PermissionsVerifierPrx = ::Ice::__declareProxy('::Glacier2::PermissionsVerifier')
        end

        T_PermissionsVerifier.defineClass(PermissionsVerifier, -1, true, false, nil, [], [])
        PermissionsVerifier_mixin::ICE_TYPE = T_PermissionsVerifier

        T_PermissionsVerifierPrx.defineProxy(PermissionsVerifierPrx, T_PermissionsVerifier)
        PermissionsVerifierPrx::ICE_TYPE = T_PermissionsVerifierPrx

        PermissionsVerifier_mixin::OP_checkPermissions = ::Ice::__defineOperation('checkPermissions', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, ::Ice::FormatType::SlicedFormat, [[::Ice::T_string, false, 0], [::Ice::T_string, false, 0]], [[::Ice::T_string, false, 0]], [::Ice::T_bool, false, 0], [::Glacier2::T_PermissionDeniedException])
    end

    if not defined?(::Glacier2::SSLPermissionsVerifier_mixin)
        module SSLPermissionsVerifier_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Glacier2::SSLPermissionsVerifier', '::Ice::Object']
            end

            def ice_id(current=nil)
                '::Glacier2::SSLPermissionsVerifier'
            end

            #
            # Operation signatures.
            #
            # def authorize(info, current=nil)

            def inspect
                ::Ice::__stringify(self, T_SSLPermissionsVerifier)
            end
        end
        class SSLPermissionsVerifier
            include SSLPermissionsVerifier_mixin
            
            def SSLPermissionsVerifier.ice_staticId()
                '::Glacier2::SSLPermissionsVerifier'
            end
        end
        module SSLPermissionsVerifierPrx_mixin

            def authorize(info, _ctx=nil)
                SSLPermissionsVerifier_mixin::OP_authorize.invoke(self, [info], _ctx)
            end
        end
        class SSLPermissionsVerifierPrx < ::Ice::ObjectPrx
            include SSLPermissionsVerifierPrx_mixin

            def SSLPermissionsVerifierPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::Glacier2::SSLPermissionsVerifier', facetOrCtx, _ctx)
            end

            def SSLPermissionsVerifierPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
            def SSLPermissionsVerifierPrx.ice_staticId()
                '::Glacier2::SSLPermissionsVerifier'
            end
        end

        if not defined?(::Glacier2::T_SSLPermissionsVerifier)
            T_SSLPermissionsVerifier = ::Ice::__declareClass('::Glacier2::SSLPermissionsVerifier')
            T_SSLPermissionsVerifierPrx = ::Ice::__declareProxy('::Glacier2::SSLPermissionsVerifier')
        end

        T_SSLPermissionsVerifier.defineClass(SSLPermissionsVerifier, -1, true, false, nil, [], [])
        SSLPermissionsVerifier_mixin::ICE_TYPE = T_SSLPermissionsVerifier

        T_SSLPermissionsVerifierPrx.defineProxy(SSLPermissionsVerifierPrx, T_SSLPermissionsVerifier)
        SSLPermissionsVerifierPrx::ICE_TYPE = T_SSLPermissionsVerifierPrx

        SSLPermissionsVerifier_mixin::OP_authorize = ::Ice::__defineOperation('authorize', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, ::Ice::FormatType::SlicedFormat, [[::Glacier2::T_SSLInfo, false, 0]], [[::Ice::T_string, false, 0]], [::Ice::T_bool, false, 0], [::Glacier2::T_PermissionDeniedException])
    end
end
